local agent_helper = require(AGENT_PATH .. "agent_helper")

AgentAdapter = {
	is_init = false,
	is_login_verify_ing = false,
	login_callback = nil,
	force_logout = false,
	login_verify_url = "cls.cp01.youyannet.com/lht/login_verify.php",
	pay_notify_url = "http://cls.cp01.youyannet.com/lht/pay.php",

	uid = "",
	session = "",
}

-- 初始化
function AgentAdapter:Init()

	if self.is_init then return end
	self.uid = string.gsub((AdapterToLua:getInstance():getDataCache("PRVE_ACCOUNT_NAME") or ""), self:GetSpid() .. "_", "")
	self.is_init = true
	AgentMs:InitLocalPush()
	PlatformBinder:JsonBind("call_agent_logout", function(arg)
		self:LogoutCallback(arg)
		return true
	end)
end

-- 平台ID
function AgentAdapter:GetSpid()
	return "lht"
end
-- 平台帐号唯一标识
function AgentAdapter:GetOpenId()
	return self.uid
end

-- 加前辍的平台帐号，全平台唯一
function AgentAdapter:GetPlatName()
	return "lht_" .. self.uid
end

--获得游戏名字
function AgentAdapter:GetGameName()
	return Language.Common.GameName[101] 
end

--获得logo资源名
function AgentAdapter:GetLogoResName()
	return "big_logo_smqyz"
end

--获得loadingbgname
function AgentAdapter:GetLoadingbgName()
	return "loading_bg_empty"
end

function AgentAdapter:Login(callback)
	if self.is_login_verify_ing then
		SysMsgCtrl.Instance:ErrorRemind("正在登录验证中，请稍等...", true)
		return
	end
	self.login_callback = callback
	agent_helper:Login(LUA_CALLBACK(self, self.LoginCallback))--设置登陆回调 

end

function AgentAdapter:OnClickBackLogin()
	local callback = function()
		AgentLoginView:OnClickBtnLogin()--重新调出登陆界面
    end
    --自己按“返回”切换账号
	PlatformBinder:JsonCall("call_agent_logout", "", "", LUA_CALLBACK(self, callback))
end

function AgentAdapter:LoginCallback(result)--登陆后回调
	print(result)
	local json_obj = cjson.decode(result)	

	local user_id = json_obj.userId
	local account = json_obj.account
	local accountSign = json_obj.accountSign
	self.session = json_obj.session

	local verify_callback = function(url, arg, data, size)
		
		self.is_login_verify_ing = false
		if size <= 0 then
			return
		end
		
		local ret_t = cjson.decode(data)
		if nil == ret_t or 0 ~= ret_t.ret or nil == ret_t.user then
			return
		end
	
		self.uid = ret_t.user.uid
		LoginController.Instance:SetLoginUserData(self:GetPlatName(), ret_t.user)
		self.login_callback(self:GetPlatName())

		agent_helper:ShowFloatButton()
	end


	self.is_login_verify_ing = true
	local now_server_time = math.floor(GLOBAL_CONFIG.server_info.server_time + (Status.NowTime - GLOBAL_CONFIG.client_time))
	local real_url = string.format("%s?spid=%s&userid=%s&account=%s&accountSign=%s&device=%s", self.login_verify_url, self:GetSpid(), user_id, account, accountSign, tostring(PlatformAdapter.GetPhoneUniqueId()))
	Log("log_real_url====" .. real_url)
	HttpClient:Request(real_url, "", verify_callback)

	return false
	
end

function AgentAdapter:LogoutCallback(result)--注销回调

	self.uid = ""
	if not LoginController.Instance:AgentLoginViewIsOpen() then
		ReStart()
	end
	return true
end

function AgentAdapter:Pay(role_id, role_name, amount, server_id, callback)--购买
	if self.uid == "" then
		SysMsgCtrl.Instance:ErrorRemind("uid为空，请联系客服")
		return
	end

	local order_id = server_id .. "_" .. self.uid .. "_" .. os.time()
	local param_obj = {}
	param_obj.url = self.pay_notify_url
	param_obj.name = self:GetGameName()
	param_obj.prodID = "0001"
	param_obj.prodName = "元宝"
	param_obj.desc = "元宝"
	param_obj.amount = tostring(amount*100)
	param_obj.session = self.session

	--Log("param_obj:" .. cjson.encode(param_obj))
	agent_helper:Pay(cjson.encode(param_obj), nil)
end

--是否支持动态下载
function AgentAdapter:IsDynamicDownloadRes()
	return true
end

-- --是否关闭推送
-- function AgentAdapter:IsClosePush()
-- 	return true
-- end

